/* cpu-monitor.c generated by valac 0.42.3, the Vala compiler
 * generated from cpu-monitor.vala, do not modify */

/* cpu-monitor.vala
 *
 * Copyright (C) 2017 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Petr Štětka <pstetka@redhat.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <glibtop/cpu.h>
#include <glibtop.h>
#include <glibtop/proctime.h>
#include <glibtop/procstate.h>
#include <gobject/gvaluecollector.h>


#define TYPE_MONITOR (monitor_get_type ())
#define MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MONITOR, Monitor))
#define IS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MONITOR))
#define MONITOR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MONITOR, MonitorIface))

typedef struct _Monitor Monitor;
typedef struct _MonitorIface MonitorIface;

#define USAGE_TYPE_PROCESS (usage_process_get_type ())
#define USAGE_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_PROCESS, UsageProcess))
#define USAGE_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_PROCESS, UsageProcessClass))
#define USAGE_IS_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_PROCESS))
#define USAGE_IS_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_PROCESS))
#define USAGE_PROCESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_PROCESS, UsageProcessClass))

typedef struct _UsageProcess UsageProcess;
typedef struct _UsageProcessClass UsageProcessClass;

#define USAGE_TYPE_CPU_MONITOR (usage_cpu_monitor_get_type ())
#define USAGE_CPU_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_CPU_MONITOR, UsageCpuMonitor))
#define USAGE_CPU_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_CPU_MONITOR, UsageCpuMonitorClass))
#define USAGE_IS_CPU_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_CPU_MONITOR))
#define USAGE_IS_CPU_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_CPU_MONITOR))
#define USAGE_CPU_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_CPU_MONITOR, UsageCpuMonitorClass))

typedef struct _UsageCpuMonitor UsageCpuMonitor;
typedef struct _UsageCpuMonitorClass UsageCpuMonitorClass;
typedef struct _UsageCpuMonitorPrivate UsageCpuMonitorPrivate;
typedef struct _UsageParamSpecCpuMonitor UsageParamSpecCpuMonitor;

struct _MonitorIface {
	GTypeInterface parent_iface;
	void (*update) (Monitor* self);
	void (*update_process) (Monitor* self, UsageProcess* * process);
};

struct _UsageCpuMonitor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	UsageCpuMonitorPrivate * priv;
};

struct _UsageCpuMonitorClass {
	GTypeClass parent_class;
	void (*finalize) (UsageCpuMonitor *self);
};

struct _UsageCpuMonitorPrivate {
	gdouble cpu_load;
	gdouble* x_cpu_load;
	gint x_cpu_load_length1;
	gint _x_cpu_load_size_;
	guint64 cpu_last_used;
	guint64 cpu_last_total;
	guint64 cpu_last_total_step;
	guint64* x_cpu_last_used;
	gint x_cpu_last_used_length1;
	gint _x_cpu_last_used_size_;
	guint64* x_cpu_last_total;
	gint x_cpu_last_total_length1;
	gint _x_cpu_last_total_size_;
};

struct _UsageParamSpecCpuMonitor {
	GParamSpec parent_instance;
};


static gint UsageCpuMonitor_private_offset;
static gpointer usage_cpu_monitor_parent_class = NULL;
static MonitorIface * usage_cpu_monitor_monitor_parent_iface = NULL;

GType usage_process_get_type (void) G_GNUC_CONST;
GType monitor_get_type (void) G_GNUC_CONST;
gpointer usage_cpu_monitor_ref (gpointer instance);
void usage_cpu_monitor_unref (gpointer instance);
GParamSpec* usage_param_spec_cpu_monitor (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
void usage_value_set_cpu_monitor (GValue* value,
                                  gpointer v_object);
void usage_value_take_cpu_monitor (GValue* value,
                                   gpointer v_object);
gpointer usage_value_get_cpu_monitor (const GValue* value);
GType usage_cpu_monitor_get_type (void) G_GNUC_CONST;
UsageCpuMonitor* usage_cpu_monitor_new (void);
UsageCpuMonitor* usage_cpu_monitor_construct (GType object_type);
static void usage_cpu_monitor_real_update (Monitor* base);
static guint64* _vala_array_dup1 (guint64* self,
                           int length);
static guint64* _vala_array_dup2 (guint64* self,
                           int length);
gdouble usage_cpu_monitor_get_cpu_load (UsageCpuMonitor* self);
gdouble* usage_cpu_monitor_get_x_cpu_load (UsageCpuMonitor* self,
                                           int* result_length1);
static gdouble* _vala_array_dup3 (gdouble* self,
                           int length);
static void usage_cpu_monitor_real_update_process (Monitor* base,
                                            UsageProcess* * process);
GPid usage_process_get_pid (UsageProcess* self);
void usage_process_set_last_processor (UsageProcess* self,
                                       guint value);
guint64 usage_process_get_cpu_last_used (UsageProcess* self);
void usage_process_set_cpu_load (UsageProcess* self,
                                 gdouble value);
void usage_process_set_cpu_last_used (UsageProcess* self,
                                      guint64 value);
guint usage_process_get_last_processor (UsageProcess* self);
void usage_process_set_x_cpu_last_used (UsageProcess* self,
                                        guint64 value);
static void usage_cpu_monitor_finalize (UsageCpuMonitor * obj);


static inline gpointer
usage_cpu_monitor_get_instance_private (UsageCpuMonitor* self)
{
	return G_STRUCT_MEMBER_P (self, UsageCpuMonitor_private_offset);
}


UsageCpuMonitor*
usage_cpu_monitor_construct (GType object_type)
{
	UsageCpuMonitor* self = NULL;
	gdouble* _tmp0_;
	guint64* _tmp1_;
	guint64* _tmp2_;
#line 33 "../src/cpu-monitor.vala"
	self = (UsageCpuMonitor*) g_type_create_instance (object_type);
#line 35 "../src/cpu-monitor.vala"
	_tmp0_ = g_new0 (gdouble, g_get_num_processors ());
#line 35 "../src/cpu-monitor.vala"
	self->priv->x_cpu_load = (g_free (self->priv->x_cpu_load), NULL);
#line 35 "../src/cpu-monitor.vala"
	self->priv->x_cpu_load = _tmp0_;
#line 35 "../src/cpu-monitor.vala"
	self->priv->x_cpu_load_length1 = g_get_num_processors ();
#line 35 "../src/cpu-monitor.vala"
	self->priv->_x_cpu_load_size_ = self->priv->x_cpu_load_length1;
#line 36 "../src/cpu-monitor.vala"
	_tmp1_ = g_new0 (guint64, g_get_num_processors ());
#line 36 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_used = (g_free (self->priv->x_cpu_last_used), NULL);
#line 36 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_used = _tmp1_;
#line 36 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_used_length1 = g_get_num_processors ();
#line 36 "../src/cpu-monitor.vala"
	self->priv->_x_cpu_last_used_size_ = self->priv->x_cpu_last_used_length1;
#line 37 "../src/cpu-monitor.vala"
	_tmp2_ = g_new0 (guint64, g_get_num_processors ());
#line 37 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_total = (g_free (self->priv->x_cpu_last_total), NULL);
#line 37 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_total = _tmp2_;
#line 37 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_total_length1 = g_get_num_processors ();
#line 37 "../src/cpu-monitor.vala"
	self->priv->_x_cpu_last_total_size_ = self->priv->x_cpu_last_total_length1;
#line 33 "../src/cpu-monitor.vala"
	return self;
#line 200 "cpu-monitor.c"
}


UsageCpuMonitor*
usage_cpu_monitor_new (void)
{
#line 33 "../src/cpu-monitor.vala"
	return usage_cpu_monitor_construct (USAGE_TYPE_CPU_MONITOR);
#line 209 "cpu-monitor.c"
}


static guint64*
_vala_array_dup1 (guint64* self,
                  int length)
{
#line 57 "../src/cpu-monitor.vala"
	return g_memdup (self, length * sizeof (guint64));
#line 219 "cpu-monitor.c"
}


static guint64*
_vala_array_dup2 (guint64* self,
                  int length)
{
#line 58 "../src/cpu-monitor.vala"
	return g_memdup (self, length * sizeof (guint64));
#line 229 "cpu-monitor.c"
}


static void
usage_cpu_monitor_real_update (Monitor* base)
{
	UsageCpuMonitor * self;
	glibtop_cpu cpu_data = {0};
	glibtop_cpu _tmp0_ = {0};
	guint64 used = 0ULL;
	glibtop_cpu _tmp1_;
	guint64 _tmp2_;
	glibtop_cpu _tmp3_;
	guint64 _tmp4_;
	glibtop_cpu _tmp5_;
	guint64 _tmp6_;
	guint64 _tmp7_;
	guint64 _tmp8_;
	glibtop_cpu _tmp9_;
	guint64 _tmp10_;
	guint64 _tmp11_;
	glibtop_cpu _tmp12_;
	guint64 _tmp13_;
	guint64 _tmp14_;
	guint64* x_cpu_used = NULL;
	guint64* _tmp15_;
	gint x_cpu_used_length1;
	gint _x_cpu_used_size_;
	guint64 _tmp47_;
	glibtop_cpu _tmp48_;
	guint64 _tmp49_;
	guint64* _tmp50_;
	gint _tmp50__length1;
	guint64* _tmp51_;
	gint _tmp51__length1;
	glibtop_cpu _tmp52_;
	guint64* _tmp53_;
	gint _tmp53__length1;
#line 40 "../src/cpu-monitor.vala"
	self = (UsageCpuMonitor*) base;
#line 43 "../src/cpu-monitor.vala"
	glibtop_get_cpu (&_tmp0_);
#line 43 "../src/cpu-monitor.vala"
	cpu_data = _tmp0_;
#line 44 "../src/cpu-monitor.vala"
	_tmp1_ = cpu_data;
#line 44 "../src/cpu-monitor.vala"
	_tmp2_ = _tmp1_.user;
#line 44 "../src/cpu-monitor.vala"
	_tmp3_ = cpu_data;
#line 44 "../src/cpu-monitor.vala"
	_tmp4_ = _tmp3_.nice;
#line 44 "../src/cpu-monitor.vala"
	_tmp5_ = cpu_data;
#line 44 "../src/cpu-monitor.vala"
	_tmp6_ = _tmp5_.sys;
#line 44 "../src/cpu-monitor.vala"
	used = (_tmp2_ + _tmp4_) + _tmp6_;
#line 45 "../src/cpu-monitor.vala"
	_tmp7_ = used;
#line 45 "../src/cpu-monitor.vala"
	_tmp8_ = self->priv->cpu_last_used;
#line 45 "../src/cpu-monitor.vala"
	_tmp9_ = cpu_data;
#line 45 "../src/cpu-monitor.vala"
	_tmp10_ = _tmp9_.total;
#line 45 "../src/cpu-monitor.vala"
	_tmp11_ = self->priv->cpu_last_total;
#line 45 "../src/cpu-monitor.vala"
	self->priv->cpu_load = (((gdouble) (_tmp7_ - _tmp8_)) / (_tmp10_ - _tmp11_)) * 100;
#line 46 "../src/cpu-monitor.vala"
	_tmp12_ = cpu_data;
#line 46 "../src/cpu-monitor.vala"
	_tmp13_ = _tmp12_.total;
#line 46 "../src/cpu-monitor.vala"
	_tmp14_ = self->priv->cpu_last_total;
#line 46 "../src/cpu-monitor.vala"
	self->priv->cpu_last_total_step = _tmp13_ - _tmp14_;
#line 48 "../src/cpu-monitor.vala"
	_tmp15_ = g_new0 (guint64, g_get_num_processors ());
#line 48 "../src/cpu-monitor.vala"
	x_cpu_used = _tmp15_;
#line 48 "../src/cpu-monitor.vala"
	x_cpu_used_length1 = g_get_num_processors ();
#line 48 "../src/cpu-monitor.vala"
	_x_cpu_used_size_ = x_cpu_used_length1;
#line 316 "cpu-monitor.c"
	{
		gint i = 0;
#line 49 "../src/cpu-monitor.vala"
		i = 0;
#line 321 "cpu-monitor.c"
		{
			gboolean _tmp16_ = FALSE;
#line 49 "../src/cpu-monitor.vala"
			_tmp16_ = TRUE;
#line 49 "../src/cpu-monitor.vala"
			while (TRUE) {
#line 328 "cpu-monitor.c"
				gint _tmp18_;
				gdouble* _tmp19_;
				gint _tmp19__length1;
				guint64* _tmp20_;
				gint _tmp20__length1;
				gint _tmp21_;
				glibtop_cpu _tmp22_;
				gint _tmp23_;
				guint64 _tmp24_;
				glibtop_cpu _tmp25_;
				gint _tmp26_;
				guint64 _tmp27_;
				glibtop_cpu _tmp28_;
				gint _tmp29_;
				guint64 _tmp30_;
				guint64 _tmp31_;
				gdouble* _tmp32_;
				gint _tmp32__length1;
				gint _tmp33_;
				guint64* _tmp34_;
				gint _tmp34__length1;
				gint _tmp35_;
				guint64 _tmp36_;
				guint64* _tmp37_;
				gint _tmp37__length1;
				gint _tmp38_;
				guint64 _tmp39_;
				glibtop_cpu _tmp40_;
				gint _tmp41_;
				guint64 _tmp42_;
				guint64* _tmp43_;
				gint _tmp43__length1;
				gint _tmp44_;
				guint64 _tmp45_;
				gdouble _tmp46_;
#line 49 "../src/cpu-monitor.vala"
				if (!_tmp16_) {
#line 366 "cpu-monitor.c"
					gint _tmp17_;
#line 49 "../src/cpu-monitor.vala"
					_tmp17_ = i;
#line 49 "../src/cpu-monitor.vala"
					i = _tmp17_ + 1;
#line 372 "cpu-monitor.c"
				}
#line 49 "../src/cpu-monitor.vala"
				_tmp16_ = FALSE;
#line 49 "../src/cpu-monitor.vala"
				_tmp18_ = i;
#line 49 "../src/cpu-monitor.vala"
				_tmp19_ = self->priv->x_cpu_load;
#line 49 "../src/cpu-monitor.vala"
				_tmp19__length1 = self->priv->x_cpu_load_length1;
#line 49 "../src/cpu-monitor.vala"
				if (!(_tmp18_ < _tmp19__length1)) {
#line 49 "../src/cpu-monitor.vala"
					break;
#line 386 "cpu-monitor.c"
				}
#line 51 "../src/cpu-monitor.vala"
				_tmp20_ = x_cpu_used;
#line 51 "../src/cpu-monitor.vala"
				_tmp20__length1 = x_cpu_used_length1;
#line 51 "../src/cpu-monitor.vala"
				_tmp21_ = i;
#line 51 "../src/cpu-monitor.vala"
				_tmp22_ = cpu_data;
#line 51 "../src/cpu-monitor.vala"
				_tmp23_ = i;
#line 51 "../src/cpu-monitor.vala"
				_tmp24_ = _tmp22_.xcpu_user[_tmp23_];
#line 51 "../src/cpu-monitor.vala"
				_tmp25_ = cpu_data;
#line 51 "../src/cpu-monitor.vala"
				_tmp26_ = i;
#line 51 "../src/cpu-monitor.vala"
				_tmp27_ = _tmp25_.xcpu_nice[_tmp26_];
#line 51 "../src/cpu-monitor.vala"
				_tmp28_ = cpu_data;
#line 51 "../src/cpu-monitor.vala"
				_tmp29_ = i;
#line 51 "../src/cpu-monitor.vala"
				_tmp30_ = _tmp28_.xcpu_sys[_tmp29_];
#line 51 "../src/cpu-monitor.vala"
				_tmp20_[_tmp21_] = (_tmp24_ + _tmp27_) + _tmp30_;
#line 51 "../src/cpu-monitor.vala"
				_tmp31_ = _tmp20_[_tmp21_];
#line 52 "../src/cpu-monitor.vala"
				_tmp32_ = self->priv->x_cpu_load;
#line 52 "../src/cpu-monitor.vala"
				_tmp32__length1 = self->priv->x_cpu_load_length1;
#line 52 "../src/cpu-monitor.vala"
				_tmp33_ = i;
#line 52 "../src/cpu-monitor.vala"
				_tmp34_ = x_cpu_used;
#line 52 "../src/cpu-monitor.vala"
				_tmp34__length1 = x_cpu_used_length1;
#line 52 "../src/cpu-monitor.vala"
				_tmp35_ = i;
#line 52 "../src/cpu-monitor.vala"
				_tmp36_ = _tmp34_[_tmp35_];
#line 52 "../src/cpu-monitor.vala"
				_tmp37_ = self->priv->x_cpu_last_used;
#line 52 "../src/cpu-monitor.vala"
				_tmp37__length1 = self->priv->x_cpu_last_used_length1;
#line 52 "../src/cpu-monitor.vala"
				_tmp38_ = i;
#line 52 "../src/cpu-monitor.vala"
				_tmp39_ = _tmp37_[_tmp38_];
#line 52 "../src/cpu-monitor.vala"
				_tmp40_ = cpu_data;
#line 52 "../src/cpu-monitor.vala"
				_tmp41_ = i;
#line 52 "../src/cpu-monitor.vala"
				_tmp42_ = _tmp40_.xcpu_total[_tmp41_];
#line 52 "../src/cpu-monitor.vala"
				_tmp43_ = self->priv->x_cpu_last_total;
#line 52 "../src/cpu-monitor.vala"
				_tmp43__length1 = self->priv->x_cpu_last_total_length1;
#line 52 "../src/cpu-monitor.vala"
				_tmp44_ = i;
#line 52 "../src/cpu-monitor.vala"
				_tmp45_ = _tmp43_[_tmp44_];
#line 52 "../src/cpu-monitor.vala"
				_tmp32_[_tmp33_] = (((gdouble) (_tmp36_ - _tmp39_)) / (_tmp42_ - _tmp45_)) * 100;
#line 52 "../src/cpu-monitor.vala"
				_tmp46_ = _tmp32_[_tmp33_];
#line 456 "cpu-monitor.c"
			}
		}
	}
#line 55 "../src/cpu-monitor.vala"
	_tmp47_ = used;
#line 55 "../src/cpu-monitor.vala"
	self->priv->cpu_last_used = _tmp47_;
#line 56 "../src/cpu-monitor.vala"
	_tmp48_ = cpu_data;
#line 56 "../src/cpu-monitor.vala"
	_tmp49_ = _tmp48_.total;
#line 56 "../src/cpu-monitor.vala"
	self->priv->cpu_last_total = _tmp49_;
#line 57 "../src/cpu-monitor.vala"
	_tmp50_ = x_cpu_used;
#line 57 "../src/cpu-monitor.vala"
	_tmp50__length1 = x_cpu_used_length1;
#line 57 "../src/cpu-monitor.vala"
	_tmp51_ = (_tmp50_ != NULL) ? _vala_array_dup1 (_tmp50_, _tmp50__length1) : ((gpointer) _tmp50_);
#line 57 "../src/cpu-monitor.vala"
	_tmp51__length1 = _tmp50__length1;
#line 57 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_used = (g_free (self->priv->x_cpu_last_used), NULL);
#line 57 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_used = _tmp51_;
#line 57 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_used_length1 = _tmp51__length1;
#line 57 "../src/cpu-monitor.vala"
	self->priv->_x_cpu_last_used_size_ = self->priv->x_cpu_last_used_length1;
#line 58 "../src/cpu-monitor.vala"
	_tmp52_ = cpu_data;
#line 58 "../src/cpu-monitor.vala"
	_tmp53_ = (_tmp52_.xcpu_total != NULL) ? _vala_array_dup2 (_tmp52_.xcpu_total, 1024) : ((gpointer) _tmp52_.xcpu_total);
#line 58 "../src/cpu-monitor.vala"
	_tmp53__length1 = 1024;
#line 58 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_total = (g_free (self->priv->x_cpu_last_total), NULL);
#line 58 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_total = _tmp53_;
#line 58 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_total_length1 = _tmp53__length1;
#line 58 "../src/cpu-monitor.vala"
	self->priv->_x_cpu_last_total_size_ = self->priv->x_cpu_last_total_length1;
#line 40 "../src/cpu-monitor.vala"
	x_cpu_used = (g_free (x_cpu_used), NULL);
#line 502 "cpu-monitor.c"
}


gdouble
usage_cpu_monitor_get_cpu_load (UsageCpuMonitor* self)
{
	gdouble result = 0.0;
	gdouble _tmp0_;
#line 61 "../src/cpu-monitor.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 63 "../src/cpu-monitor.vala"
	_tmp0_ = self->priv->cpu_load;
#line 63 "../src/cpu-monitor.vala"
	result = _tmp0_;
#line 63 "../src/cpu-monitor.vala"
	return result;
#line 519 "cpu-monitor.c"
}


static gdouble*
_vala_array_dup3 (gdouble* self,
                  int length)
{
#line 68 "../src/cpu-monitor.vala"
	return g_memdup (self, length * sizeof (gdouble));
#line 529 "cpu-monitor.c"
}


gdouble*
usage_cpu_monitor_get_x_cpu_load (UsageCpuMonitor* self,
                                  int* result_length1)
{
	gdouble* result = NULL;
	gdouble* _tmp0_;
	gint _tmp0__length1;
	gdouble* _tmp1_;
	gint _tmp1__length1;
	gdouble* _tmp2_;
	gint _tmp2__length1;
#line 66 "../src/cpu-monitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 68 "../src/cpu-monitor.vala"
	_tmp0_ = self->priv->x_cpu_load;
#line 68 "../src/cpu-monitor.vala"
	_tmp0__length1 = self->priv->x_cpu_load_length1;
#line 68 "../src/cpu-monitor.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup3 (_tmp0_, _tmp0__length1) : ((gpointer) _tmp0_);
#line 68 "../src/cpu-monitor.vala"
	_tmp1__length1 = _tmp0__length1;
#line 68 "../src/cpu-monitor.vala"
	_tmp2_ = _tmp1_;
#line 68 "../src/cpu-monitor.vala"
	_tmp2__length1 = _tmp1__length1;
#line 68 "../src/cpu-monitor.vala"
	if (result_length1) {
#line 68 "../src/cpu-monitor.vala"
		*result_length1 = _tmp2__length1;
#line 562 "cpu-monitor.c"
	}
#line 68 "../src/cpu-monitor.vala"
	result = _tmp2_;
#line 68 "../src/cpu-monitor.vala"
	return result;
#line 568 "cpu-monitor.c"
}


static void
usage_cpu_monitor_real_update_process (Monitor* base,
                                       UsageProcess* * process)
{
	UsageCpuMonitor * self;
	glibtop_proc_time proc_time = {0};
	glibtop_proc_state proc_state = {0};
	GPid _tmp0_;
	GPid _tmp1_;
	glibtop_proc_time _tmp2_ = {0};
	GPid _tmp3_;
	GPid _tmp4_;
	glibtop_proc_state _tmp5_ = {0};
	glibtop_proc_state _tmp6_;
	gint _tmp7_;
	gdouble cpu_load = 0.0;
	glibtop_proc_time _tmp8_;
	guint64 _tmp9_;
	guint64 _tmp10_;
	guint64 _tmp11_;
	guint64 _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_;
	glibtop_proc_time _tmp15_;
	guint64 _tmp16_;
	glibtop_proc_time _tmp17_;
	guint _tmp18_;
	guint _tmp19_;
	guint64 _tmp20_;
	glibtop_proc_time _tmp21_;
	guint _tmp22_;
	guint _tmp23_;
	guint64 _tmp24_;
#line 71 "../src/cpu-monitor.vala"
	self = (UsageCpuMonitor*) base;
#line 71 "../src/cpu-monitor.vala"
	g_return_if_fail (*process != NULL);
#line 76 "../src/cpu-monitor.vala"
	_tmp0_ = usage_process_get_pid (*process);
#line 76 "../src/cpu-monitor.vala"
	_tmp1_ = _tmp0_;
#line 76 "../src/cpu-monitor.vala"
	glibtop_get_proc_time (&_tmp2_, _tmp1_);
#line 76 "../src/cpu-monitor.vala"
	proc_time = _tmp2_;
#line 77 "../src/cpu-monitor.vala"
	_tmp3_ = usage_process_get_pid (*process);
#line 77 "../src/cpu-monitor.vala"
	_tmp4_ = _tmp3_;
#line 77 "../src/cpu-monitor.vala"
	glibtop_get_proc_state (&_tmp5_, _tmp4_);
#line 77 "../src/cpu-monitor.vala"
	proc_state = _tmp5_;
#line 79 "../src/cpu-monitor.vala"
	_tmp6_ = proc_state;
#line 79 "../src/cpu-monitor.vala"
	_tmp7_ = _tmp6_.last_processor;
#line 79 "../src/cpu-monitor.vala"
	usage_process_set_last_processor (*process, (guint) _tmp7_);
#line 80 "../src/cpu-monitor.vala"
	_tmp8_ = proc_time;
#line 80 "../src/cpu-monitor.vala"
	_tmp9_ = _tmp8_.rtime;
#line 80 "../src/cpu-monitor.vala"
	_tmp10_ = usage_process_get_cpu_last_used (*process);
#line 80 "../src/cpu-monitor.vala"
	_tmp11_ = _tmp10_;
#line 80 "../src/cpu-monitor.vala"
	_tmp12_ = self->priv->cpu_last_total_step;
#line 80 "../src/cpu-monitor.vala"
	cpu_load = ((((gdouble) (_tmp9_ - _tmp11_)) / _tmp12_) * 100) * g_get_num_processors ();
#line 81 "../src/cpu-monitor.vala"
	_tmp13_ = cpu_load;
#line 81 "../src/cpu-monitor.vala"
	cpu_load = MIN ((gdouble) 100, _tmp13_);
#line 82 "../src/cpu-monitor.vala"
	_tmp14_ = cpu_load;
#line 82 "../src/cpu-monitor.vala"
	usage_process_set_cpu_load (*process, _tmp14_);
#line 83 "../src/cpu-monitor.vala"
	_tmp15_ = proc_time;
#line 83 "../src/cpu-monitor.vala"
	_tmp16_ = _tmp15_.rtime;
#line 83 "../src/cpu-monitor.vala"
	usage_process_set_cpu_last_used (*process, _tmp16_);
#line 84 "../src/cpu-monitor.vala"
	_tmp17_ = proc_time;
#line 84 "../src/cpu-monitor.vala"
	_tmp18_ = usage_process_get_last_processor (*process);
#line 84 "../src/cpu-monitor.vala"
	_tmp19_ = _tmp18_;
#line 84 "../src/cpu-monitor.vala"
	_tmp20_ = _tmp17_.xcpu_utime[_tmp19_];
#line 84 "../src/cpu-monitor.vala"
	_tmp21_ = proc_time;
#line 84 "../src/cpu-monitor.vala"
	_tmp22_ = usage_process_get_last_processor (*process);
#line 84 "../src/cpu-monitor.vala"
	_tmp23_ = _tmp22_;
#line 84 "../src/cpu-monitor.vala"
	_tmp24_ = _tmp21_.xcpu_stime[_tmp23_];
#line 84 "../src/cpu-monitor.vala"
	usage_process_set_x_cpu_last_used (*process, _tmp20_ + _tmp24_);
#line 675 "cpu-monitor.c"
}


static void
usage_value_cpu_monitor_init (GValue* value)
{
#line 23 "../src/cpu-monitor.vala"
	value->data[0].v_pointer = NULL;
#line 684 "cpu-monitor.c"
}


static void
usage_value_cpu_monitor_free_value (GValue* value)
{
#line 23 "../src/cpu-monitor.vala"
	if (value->data[0].v_pointer) {
#line 23 "../src/cpu-monitor.vala"
		usage_cpu_monitor_unref (value->data[0].v_pointer);
#line 695 "cpu-monitor.c"
	}
}


static void
usage_value_cpu_monitor_copy_value (const GValue* src_value,
                                    GValue* dest_value)
{
#line 23 "../src/cpu-monitor.vala"
	if (src_value->data[0].v_pointer) {
#line 23 "../src/cpu-monitor.vala"
		dest_value->data[0].v_pointer = usage_cpu_monitor_ref (src_value->data[0].v_pointer);
#line 708 "cpu-monitor.c"
	} else {
#line 23 "../src/cpu-monitor.vala"
		dest_value->data[0].v_pointer = NULL;
#line 712 "cpu-monitor.c"
	}
}


static gpointer
usage_value_cpu_monitor_peek_pointer (const GValue* value)
{
#line 23 "../src/cpu-monitor.vala"
	return value->data[0].v_pointer;
#line 722 "cpu-monitor.c"
}


static gchar*
usage_value_cpu_monitor_collect_value (GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
#line 23 "../src/cpu-monitor.vala"
	if (collect_values[0].v_pointer) {
#line 734 "cpu-monitor.c"
		UsageCpuMonitor * object;
		object = collect_values[0].v_pointer;
#line 23 "../src/cpu-monitor.vala"
		if (object->parent_instance.g_class == NULL) {
#line 23 "../src/cpu-monitor.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 741 "cpu-monitor.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 23 "../src/cpu-monitor.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 745 "cpu-monitor.c"
		}
#line 23 "../src/cpu-monitor.vala"
		value->data[0].v_pointer = usage_cpu_monitor_ref (object);
#line 749 "cpu-monitor.c"
	} else {
#line 23 "../src/cpu-monitor.vala"
		value->data[0].v_pointer = NULL;
#line 753 "cpu-monitor.c"
	}
#line 23 "../src/cpu-monitor.vala"
	return NULL;
#line 757 "cpu-monitor.c"
}


static gchar*
usage_value_cpu_monitor_lcopy_value (const GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
	UsageCpuMonitor ** object_p;
	object_p = collect_values[0].v_pointer;
#line 23 "../src/cpu-monitor.vala"
	if (!object_p) {
#line 23 "../src/cpu-monitor.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 773 "cpu-monitor.c"
	}
#line 23 "../src/cpu-monitor.vala"
	if (!value->data[0].v_pointer) {
#line 23 "../src/cpu-monitor.vala"
		*object_p = NULL;
#line 779 "cpu-monitor.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 23 "../src/cpu-monitor.vala"
		*object_p = value->data[0].v_pointer;
#line 783 "cpu-monitor.c"
	} else {
#line 23 "../src/cpu-monitor.vala"
		*object_p = usage_cpu_monitor_ref (value->data[0].v_pointer);
#line 787 "cpu-monitor.c"
	}
#line 23 "../src/cpu-monitor.vala"
	return NULL;
#line 791 "cpu-monitor.c"
}


GParamSpec*
usage_param_spec_cpu_monitor (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags)
{
	UsageParamSpecCpuMonitor* spec;
#line 23 "../src/cpu-monitor.vala"
	g_return_val_if_fail (g_type_is_a (object_type, USAGE_TYPE_CPU_MONITOR), NULL);
#line 23 "../src/cpu-monitor.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 23 "../src/cpu-monitor.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 23 "../src/cpu-monitor.vala"
	return G_PARAM_SPEC (spec);
#line 811 "cpu-monitor.c"
}


gpointer
usage_value_get_cpu_monitor (const GValue* value)
{
#line 23 "../src/cpu-monitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, USAGE_TYPE_CPU_MONITOR), NULL);
#line 23 "../src/cpu-monitor.vala"
	return value->data[0].v_pointer;
#line 822 "cpu-monitor.c"
}


void
usage_value_set_cpu_monitor (GValue* value,
                             gpointer v_object)
{
	UsageCpuMonitor * old;
#line 23 "../src/cpu-monitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, USAGE_TYPE_CPU_MONITOR));
#line 23 "../src/cpu-monitor.vala"
	old = value->data[0].v_pointer;
#line 23 "../src/cpu-monitor.vala"
	if (v_object) {
#line 23 "../src/cpu-monitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, USAGE_TYPE_CPU_MONITOR));
#line 23 "../src/cpu-monitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 23 "../src/cpu-monitor.vala"
		value->data[0].v_pointer = v_object;
#line 23 "../src/cpu-monitor.vala"
		usage_cpu_monitor_ref (value->data[0].v_pointer);
#line 845 "cpu-monitor.c"
	} else {
#line 23 "../src/cpu-monitor.vala"
		value->data[0].v_pointer = NULL;
#line 849 "cpu-monitor.c"
	}
#line 23 "../src/cpu-monitor.vala"
	if (old) {
#line 23 "../src/cpu-monitor.vala"
		usage_cpu_monitor_unref (old);
#line 855 "cpu-monitor.c"
	}
}


void
usage_value_take_cpu_monitor (GValue* value,
                              gpointer v_object)
{
	UsageCpuMonitor * old;
#line 23 "../src/cpu-monitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, USAGE_TYPE_CPU_MONITOR));
#line 23 "../src/cpu-monitor.vala"
	old = value->data[0].v_pointer;
#line 23 "../src/cpu-monitor.vala"
	if (v_object) {
#line 23 "../src/cpu-monitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, USAGE_TYPE_CPU_MONITOR));
#line 23 "../src/cpu-monitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 23 "../src/cpu-monitor.vala"
		value->data[0].v_pointer = v_object;
#line 877 "cpu-monitor.c"
	} else {
#line 23 "../src/cpu-monitor.vala"
		value->data[0].v_pointer = NULL;
#line 881 "cpu-monitor.c"
	}
#line 23 "../src/cpu-monitor.vala"
	if (old) {
#line 23 "../src/cpu-monitor.vala"
		usage_cpu_monitor_unref (old);
#line 887 "cpu-monitor.c"
	}
}


static void
usage_cpu_monitor_class_init (UsageCpuMonitorClass * klass)
{
#line 23 "../src/cpu-monitor.vala"
	usage_cpu_monitor_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/cpu-monitor.vala"
	((UsageCpuMonitorClass *) klass)->finalize = usage_cpu_monitor_finalize;
#line 23 "../src/cpu-monitor.vala"
	g_type_class_adjust_private_offset (klass, &UsageCpuMonitor_private_offset);
#line 901 "cpu-monitor.c"
}


static void
usage_cpu_monitor_monitor_interface_init (MonitorIface * iface)
{
#line 23 "../src/cpu-monitor.vala"
	usage_cpu_monitor_monitor_parent_iface = g_type_interface_peek_parent (iface);
#line 23 "../src/cpu-monitor.vala"
	iface->update = (void (*) (Monitor *)) usage_cpu_monitor_real_update;
#line 23 "../src/cpu-monitor.vala"
	iface->update_process = (void (*) (Monitor *, UsageProcess* *)) usage_cpu_monitor_real_update_process;
#line 914 "cpu-monitor.c"
}


static void
usage_cpu_monitor_instance_init (UsageCpuMonitor * self)
{
#line 23 "../src/cpu-monitor.vala"
	self->priv = usage_cpu_monitor_get_instance_private (self);
#line 27 "../src/cpu-monitor.vala"
	self->priv->cpu_last_used = (guint64) 0;
#line 28 "../src/cpu-monitor.vala"
	self->priv->cpu_last_total = (guint64) 0;
#line 29 "../src/cpu-monitor.vala"
	self->priv->cpu_last_total_step = (guint64) 0;
#line 23 "../src/cpu-monitor.vala"
	self->ref_count = 1;
#line 931 "cpu-monitor.c"
}


static void
usage_cpu_monitor_finalize (UsageCpuMonitor * obj)
{
	UsageCpuMonitor * self;
#line 23 "../src/cpu-monitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, USAGE_TYPE_CPU_MONITOR, UsageCpuMonitor);
#line 23 "../src/cpu-monitor.vala"
	g_signal_handlers_destroy (self);
#line 26 "../src/cpu-monitor.vala"
	self->priv->x_cpu_load = (g_free (self->priv->x_cpu_load), NULL);
#line 30 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_used = (g_free (self->priv->x_cpu_last_used), NULL);
#line 31 "../src/cpu-monitor.vala"
	self->priv->x_cpu_last_total = (g_free (self->priv->x_cpu_last_total), NULL);
#line 949 "cpu-monitor.c"
}


GType
usage_cpu_monitor_get_type (void)
{
	static volatile gsize usage_cpu_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&usage_cpu_monitor_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { usage_value_cpu_monitor_init, usage_value_cpu_monitor_free_value, usage_value_cpu_monitor_copy_value, usage_value_cpu_monitor_peek_pointer, "p", usage_value_cpu_monitor_collect_value, "p", usage_value_cpu_monitor_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (UsageCpuMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) usage_cpu_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UsageCpuMonitor), 0, (GInstanceInitFunc) usage_cpu_monitor_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		static const GInterfaceInfo monitor_info = { (GInterfaceInitFunc) usage_cpu_monitor_monitor_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType usage_cpu_monitor_type_id;
		usage_cpu_monitor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "UsageCpuMonitor", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_type_add_interface_static (usage_cpu_monitor_type_id, TYPE_MONITOR, &monitor_info);
		UsageCpuMonitor_private_offset = g_type_add_instance_private (usage_cpu_monitor_type_id, sizeof (UsageCpuMonitorPrivate));
		g_once_init_leave (&usage_cpu_monitor_type_id__volatile, usage_cpu_monitor_type_id);
	}
	return usage_cpu_monitor_type_id__volatile;
}


gpointer
usage_cpu_monitor_ref (gpointer instance)
{
	UsageCpuMonitor * self;
	self = instance;
#line 23 "../src/cpu-monitor.vala"
	g_atomic_int_inc (&self->ref_count);
#line 23 "../src/cpu-monitor.vala"
	return instance;
#line 981 "cpu-monitor.c"
}


void
usage_cpu_monitor_unref (gpointer instance)
{
	UsageCpuMonitor * self;
	self = instance;
#line 23 "../src/cpu-monitor.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 23 "../src/cpu-monitor.vala"
		USAGE_CPU_MONITOR_GET_CLASS (self)->finalize (self);
#line 23 "../src/cpu-monitor.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 996 "cpu-monitor.c"
	}
}



