/* graph-block.c generated by valac 0.42.3, the Vala compiler
 * generated from graph-block.vala, do not modify */

/* graph-block.vala
 *
 * Copyright (C) 2017 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Petr Štětka <pstetka@redhat.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>


#define USAGE_TYPE_GRAPH_BLOCK_TYPE (usage_graph_block_type_get_type ())

#define USAGE_TYPE_GRAPH_BLOCK (usage_graph_block_get_type ())
#define USAGE_GRAPH_BLOCK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_GRAPH_BLOCK, UsageGraphBlock))
#define USAGE_GRAPH_BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_GRAPH_BLOCK, UsageGraphBlockClass))
#define USAGE_IS_GRAPH_BLOCK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_GRAPH_BLOCK))
#define USAGE_IS_GRAPH_BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_GRAPH_BLOCK))
#define USAGE_GRAPH_BLOCK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_GRAPH_BLOCK, UsageGraphBlockClass))

typedef struct _UsageGraphBlock UsageGraphBlock;
typedef struct _UsageGraphBlockClass UsageGraphBlockClass;
typedef struct _UsageGraphBlockPrivate UsageGraphBlockPrivate;

#define USAGE_TYPE_PIE_CHART (usage_pie_chart_get_type ())
#define USAGE_PIE_CHART(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_PIE_CHART, UsagePieChart))
#define USAGE_PIE_CHART_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_PIE_CHART, UsagePieChartClass))
#define USAGE_IS_PIE_CHART(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_PIE_CHART))
#define USAGE_IS_PIE_CHART_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_PIE_CHART))
#define USAGE_PIE_CHART_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_PIE_CHART, UsagePieChartClass))

typedef struct _UsagePieChart UsagePieChart;
typedef struct _UsagePieChartClass UsagePieChartClass;

#define USAGE_TYPE_GRAPH_BLOCK_ROW (usage_graph_block_row_get_type ())
#define USAGE_GRAPH_BLOCK_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_GRAPH_BLOCK_ROW, UsageGraphBlockRow))
#define USAGE_GRAPH_BLOCK_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_GRAPH_BLOCK_ROW, UsageGraphBlockRowClass))
#define USAGE_IS_GRAPH_BLOCK_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_GRAPH_BLOCK_ROW))
#define USAGE_IS_GRAPH_BLOCK_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_GRAPH_BLOCK_ROW))
#define USAGE_GRAPH_BLOCK_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_GRAPH_BLOCK_ROW, UsageGraphBlockRowClass))

typedef struct _UsageGraphBlockRow UsageGraphBlockRow;
typedef struct _UsageGraphBlockRowClass UsageGraphBlockRowClass;
enum  {
	USAGE_GRAPH_BLOCK_0_PROPERTY,
	USAGE_GRAPH_BLOCK_NUM_PROPERTIES
};
static GParamSpec* usage_graph_block_properties[USAGE_GRAPH_BLOCK_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

typedef enum  {
	USAGE_GRAPH_BLOCK_TYPE_PROCESSOR,
	USAGE_GRAPH_BLOCK_TYPE_MEMORY,
	USAGE_GRAPH_BLOCK_TYPE_DISK,
	USAGE_GRAPH_BLOCK_TYPE_NETWORK
} UsageGraphBlockType;

struct _UsageGraphBlock {
	GtkGrid parent_instance;
	UsageGraphBlockPrivate * priv;
};

struct _UsageGraphBlockClass {
	GtkGridClass parent_class;
};

struct _UsageGraphBlockPrivate {
	UsagePieChart* graph;
	UsageGraphBlockRow* application_row;
	UsageGraphBlockRow* others_row;
	UsageGraphBlockRow* available_row;
	GtkLabel* label;
	gchar* block_name;
	gboolean show_avaiable;
	UsageGraphBlockType type;
};


static gint UsageGraphBlock_private_offset;
static gpointer usage_graph_block_parent_class = NULL;

GType usage_graph_block_type_get_type (void) G_GNUC_CONST;
GType usage_graph_block_get_type (void) G_GNUC_CONST;
GType usage_pie_chart_get_type (void) G_GNUC_CONST;
GType usage_graph_block_row_get_type (void) G_GNUC_CONST;
UsageGraphBlock* usage_graph_block_new (UsageGraphBlockType type,
                                        const gchar* block_name,
                                        const gchar* app_name,
                                        gboolean show_avaiable);
UsageGraphBlock* usage_graph_block_construct (GType object_type,
                                              UsageGraphBlockType type,
                                              const gchar* block_name,
                                              const gchar* app_name,
                                              gboolean show_avaiable);
UsagePieChart* usage_pie_chart_new (void);
UsagePieChart* usage_pie_chart_construct (GType object_type);
UsageGraphBlockRow* usage_graph_block_row_new (UsageGraphBlockType type,
                                               const gchar* label_text,
                                               const gchar* css_class);
UsageGraphBlockRow* usage_graph_block_row_construct (GType object_type,
                                                     UsageGraphBlockType type,
                                                     const gchar* label_text,
                                                     const gchar* css_class);
void usage_graph_block_update (UsageGraphBlock* self,
                               guint64 application,
                               guint64 other,
                               guint64 all,
                               gint processor_core);
void usage_pie_chart_update (UsagePieChart* self,
                             gint used_percentages,
                             gint other_percentages);
void usage_graph_block_row_update (UsageGraphBlockRow* self,
                                   guint64 value);
static void usage_graph_block_finalize (GObject * obj);


GType
usage_graph_block_type_get_type (void)
{
	static volatile gsize usage_graph_block_type_type_id__volatile = 0;
	if (g_once_init_enter (&usage_graph_block_type_type_id__volatile)) {
		static const GEnumValue values[] = {{USAGE_GRAPH_BLOCK_TYPE_PROCESSOR, "USAGE_GRAPH_BLOCK_TYPE_PROCESSOR", "processor"}, {USAGE_GRAPH_BLOCK_TYPE_MEMORY, "USAGE_GRAPH_BLOCK_TYPE_MEMORY", "memory"}, {USAGE_GRAPH_BLOCK_TYPE_DISK, "USAGE_GRAPH_BLOCK_TYPE_DISK", "disk"}, {USAGE_GRAPH_BLOCK_TYPE_NETWORK, "USAGE_GRAPH_BLOCK_TYPE_NETWORK", "network"}, {0, NULL, NULL}};
		GType usage_graph_block_type_type_id;
		usage_graph_block_type_type_id = g_enum_register_static ("UsageGraphBlockType", values);
		g_once_init_leave (&usage_graph_block_type_type_id__volatile, usage_graph_block_type_type_id);
	}
	return usage_graph_block_type_type_id__volatile;
}


static inline gpointer
usage_graph_block_get_instance_private (UsageGraphBlock* self)
{
	return G_STRUCT_MEMBER_P (self, UsageGraphBlock_private_offset);
}


UsageGraphBlock*
usage_graph_block_construct (GType object_type,
                             UsageGraphBlockType type,
                             const gchar* block_name,
                             const gchar* app_name,
                             gboolean show_avaiable)
{
	UsageGraphBlock * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	UsagePieChart* _tmp8_;
	UsagePieChart* _tmp9_;
	UsagePieChart* _tmp10_;
	UsagePieChart* _tmp11_;
	UsagePieChart* _tmp12_;
	UsageGraphBlockRow* _tmp13_;
	UsageGraphBlockRow* _tmp14_;
	GtkBox* box = NULL;
	GtkBox* _tmp16_;
	GtkBox* _tmp17_;
	GtkBox* _tmp18_;
	GtkBox* _tmp19_;
	UsageGraphBlockRow* _tmp20_;
	GtkBox* _tmp21_;
	UsageGraphBlockRow* _tmp22_;
	GtkBox* _tmp25_;
#line 48 "../src/graph-block.vala"
	g_return_val_if_fail (block_name != NULL, NULL);
#line 48 "../src/graph-block.vala"
	g_return_val_if_fail (app_name != NULL, NULL);
#line 48 "../src/graph-block.vala"
	self = (UsageGraphBlock*) g_object_new (object_type, NULL);
#line 50 "../src/graph-block.vala"
	self->priv->type = type;
#line 51 "../src/graph-block.vala"
	g_object_set ((GtkWidget*) self, "expand", TRUE, NULL);
#line 52 "../src/graph-block.vala"
	_tmp0_ = g_strdup (block_name);
#line 52 "../src/graph-block.vala"
	_g_free0 (self->priv->block_name);
#line 52 "../src/graph-block.vala"
	self->priv->block_name = _tmp0_;
#line 53 "../src/graph-block.vala"
	self->priv->show_avaiable = show_avaiable;
#line 54 "../src/graph-block.vala"
	_tmp1_ = g_strconcat ("<span font_desc=\"11.0\"><b>", block_name, NULL);
#line 54 "../src/graph-block.vala"
	_tmp2_ = _tmp1_;
#line 54 "../src/graph-block.vala"
	_tmp3_ = g_strconcat (_tmp2_, "</b></span>", NULL);
#line 54 "../src/graph-block.vala"
	_tmp4_ = _tmp3_;
#line 54 "../src/graph-block.vala"
	_tmp5_ = (GtkLabel*) gtk_label_new (_tmp4_);
#line 54 "../src/graph-block.vala"
	g_object_ref_sink (_tmp5_);
#line 54 "../src/graph-block.vala"
	_g_object_unref0 (self->priv->label);
#line 54 "../src/graph-block.vala"
	self->priv->label = _tmp5_;
#line 54 "../src/graph-block.vala"
	_g_free0 (_tmp4_);
#line 54 "../src/graph-block.vala"
	_g_free0 (_tmp2_);
#line 55 "../src/graph-block.vala"
	_tmp6_ = self->priv->label;
#line 55 "../src/graph-block.vala"
	gtk_label_set_use_markup (_tmp6_, TRUE);
#line 56 "../src/graph-block.vala"
	_tmp7_ = self->priv->label;
#line 56 "../src/graph-block.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp7_, 0, 0, 1, 1);
#line 58 "../src/graph-block.vala"
	_tmp8_ = usage_pie_chart_new ();
#line 58 "../src/graph-block.vala"
	g_object_ref_sink (_tmp8_);
#line 58 "../src/graph-block.vala"
	_g_object_unref0 (self->priv->graph);
#line 58 "../src/graph-block.vala"
	self->priv->graph = _tmp8_;
#line 59 "../src/graph-block.vala"
	_tmp9_ = self->priv->graph;
#line 59 "../src/graph-block.vala"
	g_object_set ((GtkWidget*) _tmp9_, "margin", 15, NULL);
#line 60 "../src/graph-block.vala"
	_tmp10_ = self->priv->graph;
#line 60 "../src/graph-block.vala"
	g_object_set ((GtkWidget*) _tmp10_, "height-request", 90, NULL);
#line 61 "../src/graph-block.vala"
	_tmp11_ = self->priv->graph;
#line 61 "../src/graph-block.vala"
	g_object_set ((GtkWidget*) _tmp11_, "width-request", 90, NULL);
#line 62 "../src/graph-block.vala"
	_tmp12_ = self->priv->graph;
#line 62 "../src/graph-block.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp12_, 0, 1, 1, 1);
#line 64 "../src/graph-block.vala"
	_tmp13_ = usage_graph_block_row_new (type, app_name, "used");
#line 64 "../src/graph-block.vala"
	g_object_ref_sink (_tmp13_);
#line 64 "../src/graph-block.vala"
	_g_object_unref0 (self->priv->application_row);
#line 64 "../src/graph-block.vala"
	self->priv->application_row = _tmp13_;
#line 65 "../src/graph-block.vala"
	_tmp14_ = usage_graph_block_row_new (type, _ ("Others"), "others");
#line 65 "../src/graph-block.vala"
	g_object_ref_sink (_tmp14_);
#line 65 "../src/graph-block.vala"
	_g_object_unref0 (self->priv->others_row);
#line 65 "../src/graph-block.vala"
	self->priv->others_row = _tmp14_;
#line 66 "../src/graph-block.vala"
	if (show_avaiable) {
#line 283 "graph-block.c"
		UsageGraphBlockRow* _tmp15_;
#line 67 "../src/graph-block.vala"
		_tmp15_ = usage_graph_block_row_new (type, _ ("Available"), "available");
#line 67 "../src/graph-block.vala"
		g_object_ref_sink (_tmp15_);
#line 67 "../src/graph-block.vala"
		_g_object_unref0 (self->priv->available_row);
#line 67 "../src/graph-block.vala"
		self->priv->available_row = _tmp15_;
#line 293 "graph-block.c"
	}
#line 69 "../src/graph-block.vala"
	_tmp16_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 69 "../src/graph-block.vala"
	g_object_ref_sink (_tmp16_);
#line 69 "../src/graph-block.vala"
	box = _tmp16_;
#line 70 "../src/graph-block.vala"
	_tmp17_ = box;
#line 70 "../src/graph-block.vala"
	gtk_widget_set_margin_left ((GtkWidget*) _tmp17_, 15);
#line 71 "../src/graph-block.vala"
	_tmp18_ = box;
#line 71 "../src/graph-block.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp18_, GTK_ALIGN_CENTER);
#line 72 "../src/graph-block.vala"
	_tmp19_ = box;
#line 72 "../src/graph-block.vala"
	_tmp20_ = self->priv->application_row;
#line 72 "../src/graph-block.vala"
	gtk_box_pack_start (_tmp19_, (GtkWidget*) _tmp20_, FALSE, FALSE, (guint) 0);
#line 73 "../src/graph-block.vala"
	_tmp21_ = box;
#line 73 "../src/graph-block.vala"
	_tmp22_ = self->priv->others_row;
#line 73 "../src/graph-block.vala"
	gtk_box_pack_start (_tmp21_, (GtkWidget*) _tmp22_, FALSE, FALSE, (guint) 0);
#line 74 "../src/graph-block.vala"
	if (show_avaiable) {
#line 323 "graph-block.c"
		GtkBox* _tmp23_;
		UsageGraphBlockRow* _tmp24_;
#line 75 "../src/graph-block.vala"
		_tmp23_ = box;
#line 75 "../src/graph-block.vala"
		_tmp24_ = self->priv->available_row;
#line 75 "../src/graph-block.vala"
		gtk_box_pack_start (_tmp23_, (GtkWidget*) _tmp24_, FALSE, FALSE, (guint) 0);
#line 332 "graph-block.c"
	}
#line 76 "../src/graph-block.vala"
	_tmp25_ = box;
#line 76 "../src/graph-block.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp25_, 1, 1, 1, 1);
#line 48 "../src/graph-block.vala"
	_g_object_unref0 (box);
#line 48 "../src/graph-block.vala"
	return self;
#line 342 "graph-block.c"
}


UsageGraphBlock*
usage_graph_block_new (UsageGraphBlockType type,
                       const gchar* block_name,
                       const gchar* app_name,
                       gboolean show_avaiable)
{
#line 48 "../src/graph-block.vala"
	return usage_graph_block_construct (USAGE_TYPE_GRAPH_BLOCK, type, block_name, app_name, show_avaiable);
#line 354 "graph-block.c"
}


void
usage_graph_block_update (UsageGraphBlock* self,
                          guint64 application,
                          guint64 other,
                          guint64 all,
                          gint processor_core)
{
	gint application_percentages = 0;
	gint other_percentages = 0;
	UsagePieChart* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	UsageGraphBlockRow* _tmp23_;
	UsageGraphBlockRow* _tmp24_;
	gboolean _tmp25_;
#line 79 "../src/graph-block.vala"
	g_return_if_fail (self != NULL);
#line 81 "../src/graph-block.vala"
	if (processor_core != -1) {
#line 377 "graph-block.c"
		GtkLabel* _tmp0_;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		GtkLabel* _tmp12_;
#line 83 "../src/graph-block.vala"
		_tmp0_ = self->priv->label;
#line 83 "../src/graph-block.vala"
		_tmp1_ = self->priv->block_name;
#line 83 "../src/graph-block.vala"
		_tmp2_ = g_strconcat ("<span font_desc=\"11.0\"><b>", _tmp1_, NULL);
#line 83 "../src/graph-block.vala"
		_tmp3_ = _tmp2_;
#line 83 "../src/graph-block.vala"
		_tmp4_ = g_strconcat (_tmp3_, " ", NULL);
#line 83 "../src/graph-block.vala"
		_tmp5_ = _tmp4_;
#line 83 "../src/graph-block.vala"
		_tmp6_ = g_strdup_printf ("%i", processor_core);
#line 83 "../src/graph-block.vala"
		_tmp7_ = _tmp6_;
#line 83 "../src/graph-block.vala"
		_tmp8_ = g_strconcat (_tmp5_, _tmp7_, NULL);
#line 83 "../src/graph-block.vala"
		_tmp9_ = _tmp8_;
#line 83 "../src/graph-block.vala"
		_tmp10_ = g_strconcat (_tmp9_, "</b></span>", NULL);
#line 83 "../src/graph-block.vala"
		_tmp11_ = _tmp10_;
#line 83 "../src/graph-block.vala"
		gtk_label_set_text (_tmp0_, _tmp11_);
#line 83 "../src/graph-block.vala"
		_g_free0 (_tmp11_);
#line 83 "../src/graph-block.vala"
		_g_free0 (_tmp9_);
#line 83 "../src/graph-block.vala"
		_g_free0 (_tmp7_);
#line 83 "../src/graph-block.vala"
		_g_free0 (_tmp5_);
#line 83 "../src/graph-block.vala"
		_g_free0 (_tmp3_);
#line 84 "../src/graph-block.vala"
		_tmp12_ = self->priv->label;
#line 84 "../src/graph-block.vala"
		gtk_label_set_use_markup (_tmp12_, TRUE);
#line 431 "graph-block.c"
	} else {
		GtkLabel* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		GtkLabel* _tmp19_;
#line 88 "../src/graph-block.vala"
		_tmp13_ = self->priv->label;
#line 88 "../src/graph-block.vala"
		_tmp14_ = self->priv->block_name;
#line 88 "../src/graph-block.vala"
		_tmp15_ = g_strconcat ("<span font_desc=\"11.0\"><b>", _tmp14_, NULL);
#line 88 "../src/graph-block.vala"
		_tmp16_ = _tmp15_;
#line 88 "../src/graph-block.vala"
		_tmp17_ = g_strconcat (_tmp16_, "</b></span>", NULL);
#line 88 "../src/graph-block.vala"
		_tmp18_ = _tmp17_;
#line 88 "../src/graph-block.vala"
		gtk_label_set_text (_tmp13_, _tmp18_);
#line 88 "../src/graph-block.vala"
		_g_free0 (_tmp18_);
#line 88 "../src/graph-block.vala"
		_g_free0 (_tmp16_);
#line 89 "../src/graph-block.vala"
		_tmp19_ = self->priv->label;
#line 89 "../src/graph-block.vala"
		gtk_label_set_use_markup (_tmp19_, TRUE);
#line 462 "graph-block.c"
	}
#line 92 "../src/graph-block.vala"
	application_percentages = 0;
#line 93 "../src/graph-block.vala"
	if (all != ((guint64) 0)) {
#line 94 "../src/graph-block.vala"
		application_percentages = (gint) ((((gdouble) application) / all) * 100);
#line 470 "graph-block.c"
	}
#line 96 "../src/graph-block.vala"
	other_percentages = 0;
#line 97 "../src/graph-block.vala"
	if (all != ((guint64) 0)) {
#line 98 "../src/graph-block.vala"
		other_percentages = (gint) ((((gdouble) other) / all) * 100);
#line 478 "graph-block.c"
	}
#line 100 "../src/graph-block.vala"
	_tmp20_ = self->priv->graph;
#line 100 "../src/graph-block.vala"
	_tmp21_ = application_percentages;
#line 100 "../src/graph-block.vala"
	_tmp22_ = other_percentages;
#line 100 "../src/graph-block.vala"
	usage_pie_chart_update (_tmp20_, _tmp21_, _tmp22_);
#line 101 "../src/graph-block.vala"
	_tmp23_ = self->priv->application_row;
#line 101 "../src/graph-block.vala"
	usage_graph_block_row_update (_tmp23_, application);
#line 102 "../src/graph-block.vala"
	_tmp24_ = self->priv->others_row;
#line 102 "../src/graph-block.vala"
	usage_graph_block_row_update (_tmp24_, other);
#line 103 "../src/graph-block.vala"
	_tmp25_ = self->priv->show_avaiable;
#line 103 "../src/graph-block.vala"
	if (_tmp25_) {
#line 500 "graph-block.c"
		UsageGraphBlockRow* _tmp26_;
#line 104 "../src/graph-block.vala"
		_tmp26_ = self->priv->available_row;
#line 104 "../src/graph-block.vala"
		usage_graph_block_row_update (_tmp26_, (all - other) - application);
#line 506 "graph-block.c"
	}
}


static void
usage_graph_block_base_init (UsageGraphBlockClass * klass)
{
#line 45 "../src/graph-block.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "GraphBlock");
#line 516 "graph-block.c"
}


static void
usage_graph_block_class_init (UsageGraphBlockClass * klass)
{
#line 32 "../src/graph-block.vala"
	usage_graph_block_parent_class = g_type_class_peek_parent (klass);
#line 32 "../src/graph-block.vala"
	g_type_class_adjust_private_offset (klass, &UsageGraphBlock_private_offset);
#line 32 "../src/graph-block.vala"
	G_OBJECT_CLASS (klass)->finalize = usage_graph_block_finalize;
#line 529 "graph-block.c"
}


static void
usage_graph_block_instance_init (UsageGraphBlock * self)
{
#line 32 "../src/graph-block.vala"
	self->priv = usage_graph_block_get_instance_private (self);
#line 538 "graph-block.c"
}


static void
usage_graph_block_finalize (GObject * obj)
{
	UsageGraphBlock * self;
#line 32 "../src/graph-block.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, USAGE_TYPE_GRAPH_BLOCK, UsageGraphBlock);
#line 34 "../src/graph-block.vala"
	_g_object_unref0 (self->priv->graph);
#line 35 "../src/graph-block.vala"
	_g_object_unref0 (self->priv->application_row);
#line 36 "../src/graph-block.vala"
	_g_object_unref0 (self->priv->others_row);
#line 37 "../src/graph-block.vala"
	_g_object_unref0 (self->priv->available_row);
#line 38 "../src/graph-block.vala"
	_g_object_unref0 (self->priv->label);
#line 39 "../src/graph-block.vala"
	_g_free0 (self->priv->block_name);
#line 32 "../src/graph-block.vala"
	G_OBJECT_CLASS (usage_graph_block_parent_class)->finalize (obj);
#line 562 "graph-block.c"
}


GType
usage_graph_block_get_type (void)
{
	static volatile gsize usage_graph_block_type_id__volatile = 0;
	if (g_once_init_enter (&usage_graph_block_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UsageGraphBlockClass), (GBaseInitFunc) usage_graph_block_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) usage_graph_block_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UsageGraphBlock), 0, (GInstanceInitFunc) usage_graph_block_instance_init, NULL };
		GType usage_graph_block_type_id;
		usage_graph_block_type_id = g_type_register_static (gtk_grid_get_type (), "UsageGraphBlock", &g_define_type_info, 0);
		UsageGraphBlock_private_offset = g_type_add_instance_private (usage_graph_block_type_id, sizeof (UsageGraphBlockPrivate));
		g_once_init_leave (&usage_graph_block_type_id__volatile, usage_graph_block_type_id);
	}
	return usage_graph_block_type_id__volatile;
}



