/* memory-graph-table.c generated by valac 0.42.3, the Vala compiler
 * generated from memory-graph-table.vala, do not modify */

/* memory-graph-table.vala
 *
 * Copyright (C) 2017 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Petr Štětka <pstetka@redhat.com>
 */


#include <glib.h>
#include <glib-object.h>
#include "realtime-graphs.h"
#include <gio/gio.h>
#include <float.h>
#include <math.h>


#define USAGE_TYPE_MEMORY_GRAPH_TABLE (usage_memory_graph_table_get_type ())
#define USAGE_MEMORY_GRAPH_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_MEMORY_GRAPH_TABLE, UsageMemoryGraphTable))
#define USAGE_MEMORY_GRAPH_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_MEMORY_GRAPH_TABLE, UsageMemoryGraphTableClass))
#define USAGE_IS_MEMORY_GRAPH_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_MEMORY_GRAPH_TABLE))
#define USAGE_IS_MEMORY_GRAPH_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_MEMORY_GRAPH_TABLE))
#define USAGE_MEMORY_GRAPH_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_MEMORY_GRAPH_TABLE, UsageMemoryGraphTableClass))

typedef struct _UsageMemoryGraphTable UsageMemoryGraphTable;
typedef struct _UsageMemoryGraphTableClass UsageMemoryGraphTableClass;
typedef struct _UsageMemoryGraphTablePrivate UsageMemoryGraphTablePrivate;
enum  {
	USAGE_MEMORY_GRAPH_TABLE_0_PROPERTY,
	USAGE_MEMORY_GRAPH_TABLE_NUM_PROPERTIES
};
static GParamSpec* usage_memory_graph_table_properties[USAGE_MEMORY_GRAPH_TABLE_NUM_PROPERTIES];

#define USAGE_TYPE_SETTINGS (usage_settings_get_type ())
#define USAGE_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_SETTINGS, UsageSettings))
#define USAGE_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_SETTINGS, UsageSettingsClass))
#define USAGE_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_SETTINGS))
#define USAGE_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_SETTINGS))
#define USAGE_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_SETTINGS, UsageSettingsClass))

typedef struct _UsageSettings UsageSettings;
typedef struct _UsageSettingsClass UsageSettingsClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define USAGE_TYPE_SYSTEM_MONITOR (usage_system_monitor_get_type ())
#define USAGE_SYSTEM_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_SYSTEM_MONITOR, UsageSystemMonitor))
#define USAGE_SYSTEM_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_SYSTEM_MONITOR, UsageSystemMonitorClass))
#define USAGE_IS_SYSTEM_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_SYSTEM_MONITOR))
#define USAGE_IS_SYSTEM_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_SYSTEM_MONITOR))
#define USAGE_SYSTEM_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_SYSTEM_MONITOR, UsageSystemMonitorClass))

typedef struct _UsageSystemMonitor UsageSystemMonitor;
typedef struct _UsageSystemMonitorClass UsageSystemMonitorClass;
enum  {
	USAGE_MEMORY_GRAPH_TABLE_BIG_RAM_USAGE_SIGNAL,
	USAGE_MEMORY_GRAPH_TABLE_SMALL_RAM_USAGE_SIGNAL,
	USAGE_MEMORY_GRAPH_TABLE_NUM_SIGNALS
};
static guint usage_memory_graph_table_signals[USAGE_MEMORY_GRAPH_TABLE_NUM_SIGNALS] = {0};

struct _UsageMemoryGraphTable {
	RgTable parent_instance;
	UsageMemoryGraphTablePrivate * priv;
};

struct _UsageMemoryGraphTableClass {
	RgTableClass parent_class;
};

struct _UsageMemoryGraphTablePrivate {
	gboolean change_big_ram_usage;
	gboolean change_small_ram_usage;
};


static gint UsageMemoryGraphTable_private_offset;
static gpointer usage_memory_graph_table_parent_class = NULL;

GType usage_memory_graph_table_get_type (void) G_GNUC_CONST;
#define USAGE_MEMORY_GRAPH_TABLE_column_ram_id 0
#define USAGE_MEMORY_GRAPH_TABLE_column_swap_id 1
UsageMemoryGraphTable* usage_memory_graph_table_new (void);
UsageMemoryGraphTable* usage_memory_graph_table_construct (GType object_type);
GType usage_settings_get_type (void) G_GNUC_CONST;
UsageSettings* usage_settings_get_default (void);
guint usage_settings_get_graph_timespan (UsageSettings* self);
guint usage_settings_get_graph_max_samples (UsageSettings* self);
guint usage_settings_get_graph_update_interval (UsageSettings* self);
static gboolean usage_memory_graph_table_update_data (UsageMemoryGraphTable* self);
static gboolean _usage_memory_graph_table_update_data_gsource_func (gpointer self);
GType usage_system_monitor_get_type (void) G_GNUC_CONST;
UsageSystemMonitor* usage_system_monitor_get_default (void);
guint64 usage_system_monitor_get_ram_total (UsageSystemMonitor* self);
guint64 usage_system_monitor_get_ram_usage (UsageSystemMonitor* self);
guint64 usage_system_monitor_get_swap_usage (UsageSystemMonitor* self);
guint64 usage_system_monitor_get_swap_total (UsageSystemMonitor* self);
static void usage_memory_graph_table_finalize (GObject * obj);


static inline gpointer
usage_memory_graph_table_get_instance_private (UsageMemoryGraphTable* self)
{
	return G_STRUCT_MEMBER_P (self, UsageMemoryGraphTable_private_offset);
}


static gboolean
_usage_memory_graph_table_update_data_gsource_func (gpointer self)
{
	gboolean result;
	result = usage_memory_graph_table_update_data ((UsageMemoryGraphTable*) self);
#line 45 "../src/memory-graph-table.vala"
	return result;
#line 130 "memory-graph-table.c"
}


UsageMemoryGraphTable*
usage_memory_graph_table_construct (GType object_type)
{
	UsageMemoryGraphTable * self = NULL;
	UsageSettings* settings = NULL;
	UsageSettings* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
	RgColumn* column_ram = NULL;
	RgColumn* _tmp5_;
	RgColumn* column_swap = NULL;
	RgColumn* _tmp6_;
	guint _tmp7_;
	guint _tmp8_;
#line 34 "../src/memory-graph-table.vala"
	self = (UsageMemoryGraphTable*) g_object_new (object_type, NULL);
#line 36 "../src/memory-graph-table.vala"
	_tmp0_ = usage_settings_get_default ();
#line 36 "../src/memory-graph-table.vala"
	settings = _tmp0_;
#line 37 "../src/memory-graph-table.vala"
	_tmp1_ = usage_settings_get_graph_timespan (settings);
#line 37 "../src/memory-graph-table.vala"
	_tmp2_ = _tmp1_;
#line 37 "../src/memory-graph-table.vala"
	rg_table_set_timespan ((RgTable*) self, (GTimeSpan) (_tmp2_ * 1000));
#line 38 "../src/memory-graph-table.vala"
	_tmp3_ = usage_settings_get_graph_max_samples (settings);
#line 38 "../src/memory-graph-table.vala"
	_tmp4_ = _tmp3_;
#line 38 "../src/memory-graph-table.vala"
	rg_table_set_max_samples ((RgTable*) self, _tmp4_);
#line 40 "../src/memory-graph-table.vala"
	_tmp5_ = rg_column_new ("RAM", g_type_from_name ("gdouble"));
#line 40 "../src/memory-graph-table.vala"
	column_ram = _tmp5_;
#line 41 "../src/memory-graph-table.vala"
	rg_table_add_column ((RgTable*) self, column_ram);
#line 42 "../src/memory-graph-table.vala"
	_tmp6_ = rg_column_new ("SWAP", g_type_from_name ("gdouble"));
#line 42 "../src/memory-graph-table.vala"
	column_swap = _tmp6_;
#line 43 "../src/memory-graph-table.vala"
	rg_table_add_column ((RgTable*) self, column_swap);
#line 45 "../src/memory-graph-table.vala"
	_tmp7_ = usage_settings_get_graph_update_interval (settings);
#line 45 "../src/memory-graph-table.vala"
	_tmp8_ = _tmp7_;
#line 45 "../src/memory-graph-table.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, _tmp8_, _usage_memory_graph_table_update_data_gsource_func, g_object_ref (self), g_object_unref);
#line 34 "../src/memory-graph-table.vala"
	_g_object_unref0 (column_swap);
#line 34 "../src/memory-graph-table.vala"
	_g_object_unref0 (column_ram);
#line 34 "../src/memory-graph-table.vala"
	_g_object_unref0 (settings);
#line 34 "../src/memory-graph-table.vala"
	return self;
#line 194 "memory-graph-table.c"
}


UsageMemoryGraphTable*
usage_memory_graph_table_new (void)
{
#line 34 "../src/memory-graph-table.vala"
	return usage_memory_graph_table_construct (USAGE_TYPE_MEMORY_GRAPH_TABLE);
#line 203 "memory-graph-table.c"
}


static gboolean
usage_memory_graph_table_update_data (UsageMemoryGraphTable* self)
{
	gboolean result = FALSE;
	RgTableIter iter = {0};
	RgTableIter _tmp0_ = {0};
	UsageSystemMonitor* monitor = NULL;
	UsageSystemMonitor* _tmp1_;
	gdouble ram_usage = 0.0;
	UsageSystemMonitor* _tmp2_;
	guint64 _tmp3_;
	guint64 _tmp4_;
	gdouble swap_usage = 0.0;
	UsageSystemMonitor* _tmp11_;
	guint64 _tmp12_;
	guint64 _tmp13_;
	gdouble _tmp20_;
	gdouble _tmp21_;
	gdouble _tmp22_;
#line 48 "../src/memory-graph-table.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 51 "../src/memory-graph-table.vala"
	rg_table_push ((RgTable*) self, &_tmp0_, g_get_monotonic_time ());
#line 51 "../src/memory-graph-table.vala"
	iter = _tmp0_;
#line 53 "../src/memory-graph-table.vala"
	_tmp1_ = usage_system_monitor_get_default ();
#line 53 "../src/memory-graph-table.vala"
	monitor = _tmp1_;
#line 54 "../src/memory-graph-table.vala"
	ram_usage = (gdouble) 0;
#line 55 "../src/memory-graph-table.vala"
	_tmp2_ = monitor;
#line 55 "../src/memory-graph-table.vala"
	_tmp3_ = usage_system_monitor_get_ram_total (_tmp2_);
#line 55 "../src/memory-graph-table.vala"
	_tmp4_ = _tmp3_;
#line 55 "../src/memory-graph-table.vala"
	if (_tmp4_ != ((guint64) 0)) {
#line 246 "memory-graph-table.c"
		UsageSystemMonitor* _tmp5_;
		guint64 _tmp6_;
		guint64 _tmp7_;
		UsageSystemMonitor* _tmp8_;
		guint64 _tmp9_;
		guint64 _tmp10_;
#line 56 "../src/memory-graph-table.vala"
		_tmp5_ = monitor;
#line 56 "../src/memory-graph-table.vala"
		_tmp6_ = usage_system_monitor_get_ram_usage (_tmp5_);
#line 56 "../src/memory-graph-table.vala"
		_tmp7_ = _tmp6_;
#line 56 "../src/memory-graph-table.vala"
		_tmp8_ = monitor;
#line 56 "../src/memory-graph-table.vala"
		_tmp9_ = usage_system_monitor_get_ram_total (_tmp8_);
#line 56 "../src/memory-graph-table.vala"
		_tmp10_ = _tmp9_;
#line 56 "../src/memory-graph-table.vala"
		ram_usage = (((gdouble) _tmp7_) / _tmp10_) * 100;
#line 267 "memory-graph-table.c"
	}
#line 58 "../src/memory-graph-table.vala"
	swap_usage = (gdouble) 0;
#line 59 "../src/memory-graph-table.vala"
	_tmp11_ = monitor;
#line 59 "../src/memory-graph-table.vala"
	_tmp12_ = usage_system_monitor_get_ram_total (_tmp11_);
#line 59 "../src/memory-graph-table.vala"
	_tmp13_ = _tmp12_;
#line 59 "../src/memory-graph-table.vala"
	if (_tmp13_ != ((guint64) 0)) {
#line 279 "memory-graph-table.c"
		UsageSystemMonitor* _tmp14_;
		guint64 _tmp15_;
		guint64 _tmp16_;
		UsageSystemMonitor* _tmp17_;
		guint64 _tmp18_;
		guint64 _tmp19_;
#line 60 "../src/memory-graph-table.vala"
		_tmp14_ = monitor;
#line 60 "../src/memory-graph-table.vala"
		_tmp15_ = usage_system_monitor_get_swap_usage (_tmp14_);
#line 60 "../src/memory-graph-table.vala"
		_tmp16_ = _tmp15_;
#line 60 "../src/memory-graph-table.vala"
		_tmp17_ = monitor;
#line 60 "../src/memory-graph-table.vala"
		_tmp18_ = usage_system_monitor_get_swap_total (_tmp17_);
#line 60 "../src/memory-graph-table.vala"
		_tmp19_ = _tmp18_;
#line 60 "../src/memory-graph-table.vala"
		swap_usage = (((gdouble) _tmp16_) / _tmp19_) * 100;
#line 300 "memory-graph-table.c"
	}
#line 62 "../src/memory-graph-table.vala"
	_tmp20_ = ram_usage;
#line 62 "../src/memory-graph-table.vala"
	rg_table_iter_set (&iter, USAGE_MEMORY_GRAPH_TABLE_column_ram_id, _tmp20_, -1, NULL);
#line 63 "../src/memory-graph-table.vala"
	_tmp21_ = swap_usage;
#line 63 "../src/memory-graph-table.vala"
	rg_table_iter_set (&iter, USAGE_MEMORY_GRAPH_TABLE_column_swap_id, _tmp21_, -1, NULL);
#line 65 "../src/memory-graph-table.vala"
	_tmp22_ = ram_usage;
#line 65 "../src/memory-graph-table.vala"
	if (_tmp22_ >= ((gdouble) 90)) {
#line 314 "memory-graph-table.c"
		gboolean _tmp23_;
#line 67 "../src/memory-graph-table.vala"
		_tmp23_ = self->priv->change_big_ram_usage;
#line 67 "../src/memory-graph-table.vala"
		if (_tmp23_) {
#line 69 "../src/memory-graph-table.vala"
			g_signal_emit (self, usage_memory_graph_table_signals[USAGE_MEMORY_GRAPH_TABLE_BIG_RAM_USAGE_SIGNAL], 0);
#line 70 "../src/memory-graph-table.vala"
			self->priv->change_big_ram_usage = FALSE;
#line 71 "../src/memory-graph-table.vala"
			self->priv->change_small_ram_usage = TRUE;
#line 326 "memory-graph-table.c"
		}
	} else {
		gboolean _tmp24_;
#line 76 "../src/memory-graph-table.vala"
		_tmp24_ = self->priv->change_small_ram_usage;
#line 76 "../src/memory-graph-table.vala"
		if (_tmp24_) {
#line 78 "../src/memory-graph-table.vala"
			g_signal_emit (self, usage_memory_graph_table_signals[USAGE_MEMORY_GRAPH_TABLE_SMALL_RAM_USAGE_SIGNAL], 0);
#line 79 "../src/memory-graph-table.vala"
			self->priv->change_small_ram_usage = FALSE;
#line 80 "../src/memory-graph-table.vala"
			self->priv->change_big_ram_usage = TRUE;
#line 340 "memory-graph-table.c"
		}
	}
#line 84 "../src/memory-graph-table.vala"
	result = TRUE;
#line 84 "../src/memory-graph-table.vala"
	_g_object_unref0 (monitor);
#line 84 "../src/memory-graph-table.vala"
	return result;
#line 349 "memory-graph-table.c"
}


static void
usage_memory_graph_table_class_init (UsageMemoryGraphTableClass * klass)
{
#line 25 "../src/memory-graph-table.vala"
	usage_memory_graph_table_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/memory-graph-table.vala"
	g_type_class_adjust_private_offset (klass, &UsageMemoryGraphTable_private_offset);
#line 25 "../src/memory-graph-table.vala"
	G_OBJECT_CLASS (klass)->finalize = usage_memory_graph_table_finalize;
#line 25 "../src/memory-graph-table.vala"
	usage_memory_graph_table_signals[USAGE_MEMORY_GRAPH_TABLE_BIG_RAM_USAGE_SIGNAL] = g_signal_new ("big-ram-usage", USAGE_TYPE_MEMORY_GRAPH_TABLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 25 "../src/memory-graph-table.vala"
	usage_memory_graph_table_signals[USAGE_MEMORY_GRAPH_TABLE_SMALL_RAM_USAGE_SIGNAL] = g_signal_new ("small-ram-usage", USAGE_TYPE_MEMORY_GRAPH_TABLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 366 "memory-graph-table.c"
}


static void
usage_memory_graph_table_instance_init (UsageMemoryGraphTable * self)
{
#line 25 "../src/memory-graph-table.vala"
	self->priv = usage_memory_graph_table_get_instance_private (self);
#line 31 "../src/memory-graph-table.vala"
	self->priv->change_big_ram_usage = TRUE;
#line 32 "../src/memory-graph-table.vala"
	self->priv->change_small_ram_usage = TRUE;
#line 379 "memory-graph-table.c"
}


static void
usage_memory_graph_table_finalize (GObject * obj)
{
	UsageMemoryGraphTable * self;
#line 25 "../src/memory-graph-table.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, USAGE_TYPE_MEMORY_GRAPH_TABLE, UsageMemoryGraphTable);
#line 25 "../src/memory-graph-table.vala"
	G_OBJECT_CLASS (usage_memory_graph_table_parent_class)->finalize (obj);
#line 391 "memory-graph-table.c"
}


GType
usage_memory_graph_table_get_type (void)
{
	static volatile gsize usage_memory_graph_table_type_id__volatile = 0;
	if (g_once_init_enter (&usage_memory_graph_table_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UsageMemoryGraphTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) usage_memory_graph_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UsageMemoryGraphTable), 0, (GInstanceInitFunc) usage_memory_graph_table_instance_init, NULL };
		GType usage_memory_graph_table_type_id;
		usage_memory_graph_table_type_id = g_type_register_static (rg_table_get_type (), "UsageMemoryGraphTable", &g_define_type_info, 0);
		UsageMemoryGraphTable_private_offset = g_type_add_instance_private (usage_memory_graph_table_type_id, sizeof (UsageMemoryGraphTablePrivate));
		g_once_init_leave (&usage_memory_graph_table_type_id__volatile, usage_memory_graph_table_type_id);
	}
	return usage_memory_graph_table_type_id__volatile;
}



