/* pie-chart.c generated by valac 0.42.3, the Vala compiler
 * generated from pie-chart.vala, do not modify */

/* pie-chart.vala
 *
 * Copyright (C) 2017 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Petr Štětka <pstetka@redhat.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <float.h>
#include <math.h>


#define USAGE_TYPE_PIE_CHART (usage_pie_chart_get_type ())
#define USAGE_PIE_CHART(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_PIE_CHART, UsagePieChart))
#define USAGE_PIE_CHART_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_PIE_CHART, UsagePieChartClass))
#define USAGE_IS_PIE_CHART(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_PIE_CHART))
#define USAGE_IS_PIE_CHART_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_PIE_CHART))
#define USAGE_PIE_CHART_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_PIE_CHART, UsagePieChartClass))

typedef struct _UsagePieChart UsagePieChart;
typedef struct _UsagePieChartClass UsagePieChartClass;
typedef struct _UsagePieChartPrivate UsagePieChartPrivate;
enum  {
	USAGE_PIE_CHART_0_PROPERTY,
	USAGE_PIE_CHART_NUM_PROPERTIES
};
static GParamSpec* usage_pie_chart_properties[USAGE_PIE_CHART_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _UsagePieChart {
	GtkDrawingArea parent_instance;
	UsagePieChartPrivate * priv;
};

struct _UsagePieChartClass {
	GtkDrawingAreaClass parent_class;
};

struct _UsagePieChartPrivate {
	gint used_percentages;
	gint other_percentages;
	GdkRGBA used_color;
	GdkRGBA others_color;
	GdkRGBA available;
};


static gint UsagePieChart_private_offset;
static gpointer usage_pie_chart_parent_class = NULL;

GType usage_pie_chart_get_type (void) G_GNUC_CONST;
UsagePieChart* usage_pie_chart_new (void);
UsagePieChart* usage_pie_chart_construct (GType object_type);
static void usage_pie_chart_set_styles (UsagePieChart* self);
static gboolean __lambda71_ (UsagePieChart* self,
                      cairo_t* context);
static gboolean ___lambda71__gtk_widget_draw (GtkWidget* _sender,
                                       cairo_t* cr,
                                       gpointer self);
void usage_pie_chart_update (UsagePieChart* self,
                             gint used_percentages,
                             gint other_percentages);
static void usage_pie_chart_finalize (GObject * obj);


static inline gpointer
usage_pie_chart_get_instance_private (UsagePieChart* self)
{
	return G_STRUCT_MEMBER_P (self, UsagePieChart_private_offset);
}


static gboolean
__lambda71_ (UsagePieChart* self,
             cairo_t* context)
{
	gboolean result = FALSE;
	gint height = 0;
	gint width = 0;
	gdouble xc = 0.0;
	gint _tmp0_;
	gdouble yc = 0.0;
	gint _tmp1_;
	gdouble radius = 0.0;
	gint _tmp2_;
	gint _tmp3_;
	gdouble angle1 = 0.0;
	gdouble ratio = 0.0;
	gdouble angle2 = 0.0;
	gint _tmp4_;
	gint _tmp15_;
	gdouble _tmp27_;
	gdouble _tmp28_;
	gdouble _tmp29_;
	GdkRGBA _tmp30_;
	gdouble _tmp31_;
	gdouble _tmp32_;
	gdouble _tmp33_;
	gdouble _tmp34_;
	gdouble _tmp35_;
#line 42 "../src/pie-chart.vala"
	g_return_val_if_fail (context != NULL, FALSE);
#line 44 "../src/pie-chart.vala"
	height = gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 45 "../src/pie-chart.vala"
	width = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 47 "../src/pie-chart.vala"
	_tmp0_ = width;
#line 47 "../src/pie-chart.vala"
	xc = _tmp0_ / 2.0;
#line 48 "../src/pie-chart.vala"
	_tmp1_ = height;
#line 48 "../src/pie-chart.vala"
	yc = _tmp1_ / 2.0;
#line 49 "../src/pie-chart.vala"
	_tmp2_ = width;
#line 49 "../src/pie-chart.vala"
	_tmp3_ = height;
#line 49 "../src/pie-chart.vala"
	radius = MIN (_tmp2_, _tmp3_) / 2.0;
#line 50 "../src/pie-chart.vala"
	angle1 = (-G_PI) / 2.0;
#line 52 "../src/pie-chart.vala"
	angle2 = (-G_PI) / 2.0;
#line 54 "../src/pie-chart.vala"
	_tmp4_ = self->priv->used_percentages;
#line 54 "../src/pie-chart.vala"
	if (_tmp4_ > 0) {
#line 151 "pie-chart.c"
		gint _tmp5_;
		gdouble _tmp6_;
		gdouble _tmp7_;
		gdouble _tmp8_;
		GdkRGBA _tmp9_;
		gdouble _tmp10_;
		gdouble _tmp11_;
		gdouble _tmp12_;
		gdouble _tmp13_;
		gdouble _tmp14_;
#line 56 "../src/pie-chart.vala"
		angle1 = (-G_PI) / 2.0;
#line 57 "../src/pie-chart.vala"
		_tmp5_ = self->priv->used_percentages;
#line 57 "../src/pie-chart.vala"
		ratio = ((gdouble) _tmp5_) / 100;
#line 58 "../src/pie-chart.vala"
		_tmp6_ = ratio;
#line 58 "../src/pie-chart.vala"
		angle2 = ((_tmp6_ * 2) * G_PI) - (G_PI / 2.0);
#line 59 "../src/pie-chart.vala"
		_tmp7_ = xc;
#line 59 "../src/pie-chart.vala"
		_tmp8_ = yc;
#line 59 "../src/pie-chart.vala"
		cairo_move_to (context, _tmp7_, _tmp8_);
#line 60 "../src/pie-chart.vala"
		_tmp9_ = self->priv->used_color;
#line 60 "../src/pie-chart.vala"
		gdk_cairo_set_source_rgba (context, &_tmp9_);
#line 61 "../src/pie-chart.vala"
		_tmp10_ = xc;
#line 61 "../src/pie-chart.vala"
		_tmp11_ = yc;
#line 61 "../src/pie-chart.vala"
		_tmp12_ = radius;
#line 61 "../src/pie-chart.vala"
		_tmp13_ = angle1;
#line 61 "../src/pie-chart.vala"
		_tmp14_ = angle2;
#line 61 "../src/pie-chart.vala"
		cairo_arc (context, _tmp10_, _tmp11_, _tmp12_, _tmp13_, _tmp14_);
#line 62 "../src/pie-chart.vala"
		cairo_fill (context);
#line 196 "pie-chart.c"
	}
#line 65 "../src/pie-chart.vala"
	_tmp15_ = self->priv->other_percentages;
#line 65 "../src/pie-chart.vala"
	if (_tmp15_ > 0) {
#line 202 "pie-chart.c"
		gdouble _tmp16_;
		gint _tmp17_;
		gdouble _tmp18_;
		gdouble _tmp19_;
		gdouble _tmp20_;
		GdkRGBA _tmp21_;
		gdouble _tmp22_;
		gdouble _tmp23_;
		gdouble _tmp24_;
		gdouble _tmp25_;
		gdouble _tmp26_;
#line 67 "../src/pie-chart.vala"
		_tmp16_ = angle2;
#line 67 "../src/pie-chart.vala"
		angle1 = _tmp16_;
#line 68 "../src/pie-chart.vala"
		_tmp17_ = self->priv->other_percentages;
#line 68 "../src/pie-chart.vala"
		ratio = ((gdouble) _tmp17_) / 100;
#line 69 "../src/pie-chart.vala"
		_tmp18_ = ratio;
#line 69 "../src/pie-chart.vala"
		angle2 = ((_tmp18_ * 2) * G_PI) - (G_PI / 2.0);
#line 70 "../src/pie-chart.vala"
		_tmp19_ = xc;
#line 70 "../src/pie-chart.vala"
		_tmp20_ = yc;
#line 70 "../src/pie-chart.vala"
		cairo_move_to (context, _tmp19_, _tmp20_);
#line 71 "../src/pie-chart.vala"
		_tmp21_ = self->priv->others_color;
#line 71 "../src/pie-chart.vala"
		gdk_cairo_set_source_rgba (context, &_tmp21_);
#line 72 "../src/pie-chart.vala"
		_tmp22_ = xc;
#line 72 "../src/pie-chart.vala"
		_tmp23_ = yc;
#line 72 "../src/pie-chart.vala"
		_tmp24_ = radius;
#line 72 "../src/pie-chart.vala"
		_tmp25_ = angle1;
#line 72 "../src/pie-chart.vala"
		_tmp26_ = angle2;
#line 72 "../src/pie-chart.vala"
		cairo_arc (context, _tmp22_, _tmp23_, _tmp24_, _tmp25_, _tmp26_);
#line 73 "../src/pie-chart.vala"
		cairo_fill (context);
#line 250 "pie-chart.c"
	}
#line 76 "../src/pie-chart.vala"
	_tmp27_ = angle2;
#line 76 "../src/pie-chart.vala"
	angle1 = _tmp27_;
#line 77 "../src/pie-chart.vala"
	angle2 = (2 * G_PI) - (G_PI / 2.0);
#line 78 "../src/pie-chart.vala"
	_tmp28_ = xc;
#line 78 "../src/pie-chart.vala"
	_tmp29_ = yc;
#line 78 "../src/pie-chart.vala"
	cairo_move_to (context, _tmp28_, _tmp29_);
#line 79 "../src/pie-chart.vala"
	_tmp30_ = self->priv->available;
#line 79 "../src/pie-chart.vala"
	gdk_cairo_set_source_rgba (context, &_tmp30_);
#line 80 "../src/pie-chart.vala"
	_tmp31_ = xc;
#line 80 "../src/pie-chart.vala"
	_tmp32_ = yc;
#line 80 "../src/pie-chart.vala"
	_tmp33_ = radius;
#line 80 "../src/pie-chart.vala"
	_tmp34_ = angle1;
#line 80 "../src/pie-chart.vala"
	_tmp35_ = angle2;
#line 80 "../src/pie-chart.vala"
	cairo_arc (context, _tmp31_, _tmp32_, _tmp33_, _tmp34_, _tmp35_);
#line 81 "../src/pie-chart.vala"
	cairo_fill (context);
#line 82 "../src/pie-chart.vala"
	result = TRUE;
#line 82 "../src/pie-chart.vala"
	return result;
#line 286 "pie-chart.c"
}


static gboolean
___lambda71__gtk_widget_draw (GtkWidget* _sender,
                              cairo_t* cr,
                              gpointer self)
{
	gboolean result;
	result = __lambda71_ ((UsagePieChart*) self, cr);
#line 42 "../src/pie-chart.vala"
	return result;
#line 299 "pie-chart.c"
}


UsagePieChart*
usage_pie_chart_construct (GType object_type)
{
	UsagePieChart * self = NULL;
#line 38 "../src/pie-chart.vala"
	self = (UsagePieChart*) g_object_new (object_type, NULL);
#line 40 "../src/pie-chart.vala"
	usage_pie_chart_set_styles (self);
#line 42 "../src/pie-chart.vala"
	g_signal_connect_object ((GtkWidget*) self, "draw", (GCallback) ___lambda71__gtk_widget_draw, self, 0);
#line 38 "../src/pie-chart.vala"
	return self;
#line 315 "pie-chart.c"
}


UsagePieChart*
usage_pie_chart_new (void)
{
#line 38 "../src/pie-chart.vala"
	return usage_pie_chart_construct (USAGE_TYPE_PIE_CHART);
#line 324 "pie-chart.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 88 "../src/pie-chart.vala"
	return self ? g_object_ref (self) : NULL;
#line 333 "pie-chart.c"
}


static void
usage_pie_chart_set_styles (UsagePieChart* self)
{
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GdkRGBA _tmp2_ = {0};
	GdkRGBA _tmp3_ = {0};
	GdkRGBA _tmp4_ = {0};
#line 86 "../src/pie-chart.vala"
	g_return_if_fail (self != NULL);
#line 88 "../src/pie-chart.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 88 "../src/pie-chart.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 88 "../src/pie-chart.vala"
	context = _tmp1_;
#line 89 "../src/pie-chart.vala"
	gtk_style_context_add_class (context, "used");
#line 90 "../src/pie-chart.vala"
	gtk_style_context_get_color (context, gtk_style_context_get_state (context), &_tmp2_);
#line 90 "../src/pie-chart.vala"
	self->priv->used_color = _tmp2_;
#line 91 "../src/pie-chart.vala"
	gtk_style_context_add_class (context, "others");
#line 92 "../src/pie-chart.vala"
	gtk_style_context_get_color (context, gtk_style_context_get_state (context), &_tmp3_);
#line 92 "../src/pie-chart.vala"
	self->priv->others_color = _tmp3_;
#line 93 "../src/pie-chart.vala"
	gtk_style_context_add_class (context, "available");
#line 94 "../src/pie-chart.vala"
	gtk_style_context_get_color (context, gtk_style_context_get_state (context), &_tmp4_);
#line 94 "../src/pie-chart.vala"
	self->priv->available = _tmp4_;
#line 86 "../src/pie-chart.vala"
	_g_object_unref0 (context);
#line 374 "pie-chart.c"
}


void
usage_pie_chart_update (UsagePieChart* self,
                        gint used_percentages,
                        gint other_percentages)
{
#line 97 "../src/pie-chart.vala"
	g_return_if_fail (self != NULL);
#line 99 "../src/pie-chart.vala"
	self->priv->used_percentages = used_percentages;
#line 100 "../src/pie-chart.vala"
	self->priv->other_percentages = used_percentages + other_percentages;
#line 101 "../src/pie-chart.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 391 "pie-chart.c"
}


static void
usage_pie_chart_base_init (UsagePieChartClass * klass)
{
#line 35 "../src/pie-chart.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "PieChart");
#line 400 "pie-chart.c"
}


static void
usage_pie_chart_class_init (UsagePieChartClass * klass)
{
#line 25 "../src/pie-chart.vala"
	usage_pie_chart_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/pie-chart.vala"
	g_type_class_adjust_private_offset (klass, &UsagePieChart_private_offset);
#line 25 "../src/pie-chart.vala"
	G_OBJECT_CLASS (klass)->finalize = usage_pie_chart_finalize;
#line 413 "pie-chart.c"
}


static void
usage_pie_chart_instance_init (UsagePieChart * self)
{
#line 25 "../src/pie-chart.vala"
	self->priv = usage_pie_chart_get_instance_private (self);
#line 27 "../src/pie-chart.vala"
	self->priv->used_percentages = 0;
#line 28 "../src/pie-chart.vala"
	self->priv->other_percentages = 0;
#line 426 "pie-chart.c"
}


static void
usage_pie_chart_finalize (GObject * obj)
{
	UsagePieChart * self;
#line 25 "../src/pie-chart.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, USAGE_TYPE_PIE_CHART, UsagePieChart);
#line 25 "../src/pie-chart.vala"
	G_OBJECT_CLASS (usage_pie_chart_parent_class)->finalize (obj);
#line 438 "pie-chart.c"
}


GType
usage_pie_chart_get_type (void)
{
	static volatile gsize usage_pie_chart_type_id__volatile = 0;
	if (g_once_init_enter (&usage_pie_chart_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UsagePieChartClass), (GBaseInitFunc) usage_pie_chart_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) usage_pie_chart_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UsagePieChart), 0, (GInstanceInitFunc) usage_pie_chart_instance_init, NULL };
		GType usage_pie_chart_type_id;
		usage_pie_chart_type_id = g_type_register_static (gtk_drawing_area_get_type (), "UsagePieChart", &g_define_type_info, 0);
		UsagePieChart_private_offset = g_type_add_instance_private (usage_pie_chart_type_id, sizeof (UsagePieChartPrivate));
		g_once_init_leave (&usage_pie_chart_type_id__volatile, usage_pie_chart_type_id);
	}
	return usage_pie_chart_type_id__volatile;
}



